#include <assert.h>

void test_pointer_to_void() {
	int i = 1;
	void* pvoid = &i;
	int* pint = (int*)pvoid;
	assert(*pint == 1);
}

// Returns the sum of two ints
int sum(int a, int b) {
	return a + b;
}

// Returns the product of two ints
int product(int a, int b) {
	return a * b;
}

//Pointer to functions having two int args and returning an int
typedef int (*Fun)(int a, int b);

void test_pointer_to_function() {
	Fun f = sum;
	assert(f(1, 2) == 3);
	f = product;
	assert(f(1, 2) == 2);
}

void test_parameter_pointer_to_function(Fun f, int result) {
	assert(f(1, 2) == result);
}

void swap(int& x, int& y) {
	int temp = x;
	x = y;
	y = temp;
}

void test_references() {
	int a = 1;
	int& c = a;
	assert (c == 1);
	assert (&a == &c);
	int b = 2;
	swap(a, b);
	assert (a == 2 && b == 1);
}

int main() {
	test_pointer_to_void();
	test_pointer_to_function();
	test_parameter_pointer_to_function(sum, 3);
	test_parameter_pointer_to_function(product, 2);
	test_references();
	return 0;
}
